\def\filedate{2018/06/26}
\def\fileversion{1.0-dev}

\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{beamerfontthemeustutt}[\filedate\space Version \fileversion\space by Philipp Tempel <philipp.tempel@isw.uni-stuttgart.de>]


\RequirePackage{etoolbox}
\RequirePackage{ifxetex}
\RequirePackage{ifluatex}
\RequirePackage{pgfopts}
\ifboolexpr{bool {xetex} or bool {luatex}}{
  \@ifpackageloaded{fontspec}{
    \PassOptionsToPackage{no-math}{fontspec}
  }{
    \RequirePackage[no-math]{fontspec}
  }
  \newcounter{fontsnotfound}
  \newcommand{\checkfont}[1]{%
    \suppressfontnotfounderror=1%
    \font\x = "#1" at 10.00pt
    \selectfont
    \ifx\x\nullfont%
      \stepcounter{fontsnotfound}%
    \fi%
    \suppressfontnotfounderror=0%
  }

  \newcommand{\iffontsavailable}[3]{%
    \setcounter{fontsnotfound}{0}%
    \expandafter\forcsvlist\expandafter%
    \checkfont\expandafter{#1}%
    \ifnum\value{fontsnotfound}=0%
      #2%
    \else%
      #3%
    \fi%
  }
  \iffontsavailable{%
    Fira Sans Light,%
    Fira Sans Light Italic,%
    Fira Sans,%
    Fira Sans Italic%
  }{%
    \setsansfont[%
      ItalicFont={Fira Sans Light Italic},%
      BoldFont={Fira Sans},%
      BoldItalicFont={Fira Sans Italic},%
    ]%
    {Fira Sans Light}%
  }{%
    \iffontsavailable{%
      Fira Sans Light OT,%
      Fira Sans Light Italic OT,%
      Fira Sans OT,%
      Fira Sans Italic OT%
    }{%
      \setsansfont[ItalicFont={Fira Sans Light Italic OT},%
                   BoldFont={Fira Sans OT},%
                   BoldItalicFont={Fira Sans Italic OT}]%
                  {Fira Sans Light OT}%
    }{%
      \PackageWarning{beamerthemeustutt}{%
        Could not find Fira Sans fonts%
      }%
    }%
  }%
  \iffontsavailable{%
    Fira Mono,%
    Fira Mono Bold%
  }{%
    \setmonofont[BoldFont={Fira Mono Medium}]{Fira Mono}%
  }{%
    \iffontsavailable{%
      Fira Mono OT,%
      Fira Mono Bold OT%
    }{%
      \setmonofont[%
          BoldFont={Fira Mono Medium OT},%
        ]{Fira Mono OT}%
    }{%
      \PackageWarning{beamerthemeustutt}{%
        Could not find Fira Mono fonts%
      }%
    }%
  }%
  \AtBeginEnvironment{tabular}{%
    \addfontfeature{%
      Numbers={Monospaced}%
    }%
  }%
}{%
  \PackageWarning{beamerthemeustutt}{%
    You need to compile with XeLaTeX or LuaLaTeX to use the Fira fonts%
  }%
}%
\setbeamerfont{alerted text}{%
  series=\bfseries,%
}
\setbeamerfont{title}{%
  size=\LARGE,%
  series=\bfseries,%
}
\setbeamerfont{subtitle}{%
  size=\large,%
}
\setbeamerfont{author}{%
  size=\small,%
}
\setbeamerfont{date}{%
  size=\small,%
}
\setbeamerfont{institute}{%
  size=\scriptsize,%
}
\setbeamerfont{section title}{%
  size=\huge,%
  series=\bfseries,%
}
\setbeamerfont{subsection title}{
  size=\normalsize,%
  series=\bfseries,%
}
\setbeamerfont{section in toc}{%
  size=\normalsize,%
  series=\normalfont,%
}
\setbeamerfont{subsection in toc}{%
  size=\small,%
  series=\normalfont,%
}
\setbeamerfont{block title}{%
  size=\normalsize,%
  series=\bfseries,%
}
\setbeamerfont{block title alerted}{%
  size=\normalsize,%
  series=\bfseries,%
}
\setbeamerfont{frametitle}{%
  size=\large,%
  series=\bfseries,%
}
\setbeamerfont{framesubtitle}{%
  size=\large,%
  series=\normalfont,%
}
\setbeamerfont{caption}{%
  size=\footnotesize,%
}
\setbeamerfont{caption name}{%
  series=\bfseries,%
  size=\small,%
}
\setbeamerfont{description item}{%
  series=\bfseries,%
}
\setbeamerfont{page number in head/foot}{%
  size=\scriptsize,%
}
\setbeamerfont{bibliography entry author}{%
  size=\normalsize,%
  series=\normalfont,%
}
\setbeamerfont{bibliography entry title}{%
  size=\normalsize,%
  series=\bfseries,%
}
\setbeamerfont{bibliography entry location}{%
  size=\normalsize,%
  series=\normalfont,%
}
\setbeamerfont{bibliography entry note}{%
  size=\small,%
  series=\normalfont,%
}
\setbeamerfont{quote}{%
  size=\Large,%
  series=\bfseries,%
}
\setbeamerfont{standout}{%
  size=\huge,%
  series=\bfseries,%
}

\pgfkeys{
  /ustutt/font/titleformat title/.cd,
    .is choice,
    regular/.code={%
      \let\ustutt@titleformat\@empty%
      \setbeamerfont{title}{shape=\normalfont}%
    },
    smallcaps/.code={%
      \let\ustutt@titleformat\@empty%
      \setbeamerfont{title}{shape=\scshape}%
    },
    allsmallcaps/.code={%
      \let\ustutt@titleformat\lowercase%
      \setbeamerfont{title}{shape=\scshape}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat title=allsmallcaps can lead to problems%
      }
    },
    allcaps/.code={%
      \let\ustutt@titleformat\uppercase%
      \setbeamerfont{title}{shape=\normalfont}
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat title=allcaps can lead to problems%
      }
    },
}
\pgfkeys{
  /ustutt/font/titleformat subtitle/.cd,
    .is choice,
    regular/.code={%
      \let\ustutt@subtitleformat\@empty%
      \setbeamerfont{subtitle}{shape=\normalfont}%
    },
    smallcaps/.code={%
      \let\ustutt@subtitleformat\@empty%
      \setbeamerfont{subtitle}{shape=\scshape}%
    },
    allsmallcaps/.code={%
      \let\ustutt@subtitleformat\lowercase%
      \setbeamerfont{subtitle}{shape=\scshape}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat subtitle=allsmallcaps can lead to problems%
      }
    },
    allcaps/.code={%
      \let\ustutt@subtitleformat\uppercase%
      \setbeamerfont{subtitle}{shape=\normalfont}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat subtitle=allcaps can lead to problems%
      }
    },
}
\pgfkeys{
  /ustutt/font/titleformat section/.cd,
    .is choice,
    regular/.code={%
      \let\ustutt@sectiontitleformat\@empty%
      \setbeamerfont{section title}{shape=\normalfont}%
    },
    smallcaps/.code={%
      \let\ustutt@sectiontitleformat\@empty%
      \setbeamerfont{section title}{shape=\scshape}%
    },
    allsmallcaps/.code={%
      \let\ustutt@sectiontitleformat\MakeLowercase%
      \setbeamerfont{section title}{shape=\scshape}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat section=allsmallcaps can lead to problems%
      }
    },
    allcaps/.code={%
      \let\ustutt@sectiontitleformat\MakeUppercase%
      \setbeamerfont{section title}{shape=\normalfont}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat section=allcaps can lead to problems%
      }
    },
}
\pgfkeys{
  /ustutt/font/titleformat frame/.cd,
    .is choice,
    regular/.code={%
      \let\ustutt@frametitleformat\@empty%
      \setbeamerfont{frametitle}{shape=\normalfont}%
      \setbeamerfont{framesubtitle}{shape=\normalfont}%
    },
    smallcaps/.code={%
      \let\ustutt@frametitleformat\@empty%
      \setbeamerfont{frametitle}{shape=\scshape}%
      \setbeamerfont{framesubtitle}{shape=\scshape}%
    },
    allsmallcaps/.code={%
      \let\ustutt@frametitleformat\MakeLowercase%
      \setbeamerfont{frametitle}{shape=\scshape}%
      \setbeamerfont{framesubtitle}{shape=\scshape}%
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat frame=allsmallcaps can lead to problems%
      }
    },
    allcaps/.code={%
      \let\ustutt@frametitleformat\MakeUppercase%
      \setbeamerfont{frametitle}{shape=\normalfont}
      \setbeamerfont{framesubtitle}{shape=\normalfont}
      \PackageWarning{beamerthemeustutt}{%
        Be aware that titleformat frame=allcaps can lead to problems%
      }
    },
}
\pgfkeys{
  /ustutt/font/.cd,
  titleformattitle/.code=\pgfkeysalso{titleformat title=#1},
  titleformatsubtitle/.code=\pgfkeysalso{titleformat subtitle=#1},
  titleformatsection/.code=\pgfkeysalso{titleformat section=#1},
  titleformatframe/.code=\pgfkeysalso{titleformat frame=#1},
}
\newcommand{\ustutt@font@setdefaults}{
  \pgfkeys{/ustutt/font/.cd,
    titleformat title=regular,
    titleformat subtitle=regular,
    titleformat section=regular,
    titleformat frame=regular,
  }
}
\def\ustutt@titleformat#1{#1}
\def\ustutt@subtitleformat#1{#1}
\def\ustutt@sectiontitleformat#1{#1}
\def\ustutt@frametitleformat#1{#1}
\patchcmd{\beamer@title}%
  {\def\inserttitle{#2}}%
  {\def\inserttitle{\ustutt@titleformat{#2}}}%
  {}%
  {\PackageError{beamerfontthemeustutt}{Patching title failed}\@ehc}
\patchcmd{\beamer@subtitle}%
  {\def\insertsubtitle{#2}}%
  {\def\insertsubtitle{\ustutt@subtitleformat{#2}}}%
  {}%
  {\PackageError{beamerfontthemeustutt}{Patching subtitle failed}\@ehc}
\patchcmd{\sectionentry}
  {\def\insertsectionhead{#2}}
  {\def\insertsectionhead{\ustutt@sectiontitleformat{#2}}}
  {}
  {\PackageError{beamerfontthemeustutt}{Patching section title failed}\@ehc}
\@tempswafalse
\patchcmd{\beamer@section}
  {\edef\insertsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{\unexpanded{#1}}}}
  {\edef\insertsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{%
    \noexpand\ustutt@sectiontitleformat{\unexpanded{#1}}}}}
  {\@tempswatrue}
  {}
\patchcmd{\beamer@section}
  {\def\insertsectionhead{\hyperlink{Navigation\the\c@page}{#1}}}
  {\def\insertsectionhead{\hyperlink{Navigation\the\c@page}{%
    \ustutt@sectiontitleformat{#1}}}}
  {\@tempswatrue}
  {}
\patchcmd{\beamer@section}
  {\protected@edef\insertsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{#1}}}
  {\protected@edef\insertsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{%
    \noexpand\ustutt@sectiontitleformat{#1}}}}
  {\@tempswatrue}
  {}
\if@tempswa\else
  \PackageError{beamerfontthemeustutt}{Patching section title failed}\@ehc
\fi
\@tempswafalse
\patchcmd{\beamer@subsection}
  {\edef\insertsubsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{\unexpanded{#1}}}}
  {\edef\insertsubsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{%
    \noexpand\ustutt@sectiontitleformat{\unexpanded{#1}}}}}
  {\@tempswatrue}
  {}
\patchcmd{\beamer@subsection}
  {\def\insertsubsectionhead{\hyperlink{Navigation\the\c@page}{#1}}}
  {\def\insertsubsectionhead{\hyperlink{Navigation\the\c@page}{%
    \ustutt@sectiontitleformat{#1}}}}
  {\@tempswatrue}
  {}
\patchcmd{\beamer@subsection}
  {\protected@edef\insertsubsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{#1}}}
  {\protected@edef\insertsubsectionhead{\noexpand\hyperlink{Navigation\the\c@page}{%
    \noexpand\ustutt@sectiontitleformat{#1}}}}
  {\@tempswatrue}
  {}
\if@tempswa\else
  \PackageError{beamerfontthemeustutt}{Patching section title failed}\@ehc
\fi
\patchcmd{\beamer@@frametitle}
  {{%
      \gdef\insertframetitle{{#2\ifnum\beamer@autobreakcount>0\relax{}\space%
      \usebeamertemplate*{frametitle continuation}\fi}}%
    \gdef\beamer@frametitle{#2}%
    \gdef\beamer@shortframetitle{#1}%
    }}
  {{%
      \gdef\insertframetitle{{\ustutt@frametitleformat{#2}\ifnum%
      \beamer@autobreakcount>0\relax{}\space%
      \usebeamertemplate*{frametitle continuation}\fi}}%
    \gdef\beamer@frametitle{#2}%
    \gdef\beamer@shortframetitle{#1}%
    }}
  {}
  {\PackageError{beamerfontthemeustutt}{Patching frame title failed}\@ehc}

\ustutt@font@setdefaults

\ProcessPgfPackageOptions{/ustutt/font}

\endinput
